#include "Scenes.h"
#include <math.h>

#include <cstdlib>

#import "../../sgCore/sgCore.h"


void OnBnClickedSurfMesh()
{
  sgGetScene()->Clear();

  int x_sz = 20;
  int y_sz =20;
  SG_POINT*  pnts = new SG_POINT[x_sz*y_sz];

  for (int i=0;i<x_sz;i++)
    for (int j=0;j<y_sz;j++)
    {
      pnts[i*y_sz+j].x = i-x_sz/2;
      pnts[i*y_sz+j].y = j-y_sz/2;
      pnts[i*y_sz+j].z = 0.1*(pnts[i*y_sz+j].x*pnts[i*y_sz+j].x+
                pnts[i*y_sz+j].y*pnts[i*y_sz+j].y);
    }

  sgCObject* msh= sgSurfaces::Mesh(x_sz,y_sz,pnts);

 
  delete [] pnts;

  sgGetScene()->AttachObject(msh);
  msh->SetAttribute(SG_OA_COLOR,30);
  msh->SetAttribute(SG_OA_LINE_THICKNESS, 1);

}

void OnBnClickedSurfFace()
{
  sgGetScene()->Clear();

  
  SG_POINT tmpPnt;

  SG_SPLINE* spl2 = SG_SPLINE::Create();

  

  tmpPnt.x = -1.0; tmpPnt.y = -3.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,0);
  tmpPnt.x = -3.0; tmpPnt.y = 0.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,1);
  tmpPnt.x = -1.0; tmpPnt.y = -1.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,2);
  tmpPnt.x = 0.0; tmpPnt.y = 1.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,3);
  tmpPnt.x = -1.0; tmpPnt.y = 4.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,4);
  tmpPnt.x =3.0; tmpPnt.y = 1.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,5);
  tmpPnt.x =2.0; tmpPnt.y = -3.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,6);
  tmpPnt.x =1.0; tmpPnt.y = -1.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,7);
  tmpPnt.x =1.0; tmpPnt.y = -4.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,8);
  spl2->Close();

  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  SG_SPLINE::Delete(spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,0);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 1);

  sgC2DObject*  holes[3];

  SG_CIRCLE   cirGeo;
  SG_POINT    cirC = {0.8, 1.0, 0.0};
  SG_VECTOR    cirNor = {0.0, 0.0, 1.0};
  cirGeo.FromCenterRadiusNormal(cirC,0.8, cirNor);
  holes[0] = sgCreateCircle(cirGeo);
  sgGetScene()->AttachObject(holes[0]);
  holes[0]->SetAttribute(SG_OA_COLOR,0);
  holes[0]->SetAttribute(SG_OA_LINE_THICKNESS, 1);

  cirC.x = 1.6; cirC.y = -1.0;
  cirGeo.FromCenterRadiusNormal(cirC,0.2, cirNor);
  holes[1] = sgCreateCircle(cirGeo);
  sgGetScene()->AttachObject(holes[1]);
  holes[1]->SetAttribute(SG_OA_COLOR,0);
  holes[1]->SetAttribute(SG_OA_LINE_THICKNESS, 1);

  
  cirC.x = 0.0; cirC.y = -1.0;
  cirGeo.FromCenterRadiusNormal(cirC,0.4, cirNor);
  holes[2] = sgCreateCircle(cirGeo);
  sgGetScene()->AttachObject(holes[2]);
  holes[2]->SetAttribute(SG_OA_COLOR,0);
  holes[2]->SetAttribute(SG_OA_LINE_THICKNESS, 1);

  
  sgC3DObject* fcO = (sgC3DObject*)sgSurfaces::Face((const sgC2DObject&)(*spl2_obj),
    (const sgC2DObject**)(&holes[0]),3);

   sgGetScene()->AttachObject(fcO);
  fcO->SetAttribute(SG_OA_COLOR,50);

  SG_VECTOR transV1 = {-5,0,0};
  fcO->InitTempMatrix()->Translate(transV1);
  fcO->ApplyTempMatrix();
  fcO->DestroyTempMatrix();

}

void OnBnClickedSurfCoons3()
{
  sgGetScene()->Clear();

    SG_POINT tmpPnt;

  SG_SPLINE* spl1 = SG_SPLINE::Create();

  tmpPnt.x = -6.0; tmpPnt.y = 0.0; tmpPnt.z = -1.0;
  spl1->AddKnot(tmpPnt,0);
  tmpPnt.x = -5.0; tmpPnt.y = 0.0; tmpPnt.z = -2.0;
  spl1->AddKnot(tmpPnt,1);
  tmpPnt.x = -3.0; tmpPnt.y = 0.0; tmpPnt.z = -1.0;
  spl1->AddKnot(tmpPnt,2);
  tmpPnt.x = -2.0; tmpPnt.y = 0.0; tmpPnt.z = -2.0;
  spl1->AddKnot(tmpPnt,3);
  tmpPnt.x = -1.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl1->AddKnot(tmpPnt,4);
  tmpPnt.x =2.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl1->AddKnot(tmpPnt,5);
  tmpPnt.x =2.0; tmpPnt.y = 0.0; tmpPnt.z = 0.0;
  spl1->AddKnot(tmpPnt,6);
  tmpPnt.x =4.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl1->AddKnot(tmpPnt,7);

  sgCSpline* spl1_obj = sgCreateSpline(*spl1);
  SG_SPLINE::Delete(spl1);
  sgGetScene()->AttachObject(spl1_obj);
  spl1_obj->SetAttribute(SG_OA_COLOR,0);
  spl1_obj->SetAttribute(SG_OA_LINE_THICKNESS, 1);

  SG_SPLINE* spl2 = SG_SPLINE::Create();

  tmpPnt.x = -6.0; tmpPnt.y = 0.0; tmpPnt.z = -1.0;
  spl2->AddKnot(tmpPnt,0);
  tmpPnt.x = -6.0; tmpPnt.y = 0.5; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,1);
  tmpPnt.x = -6.0; tmpPnt.y = 2.0; tmpPnt.z = -1.0;
  spl2->AddKnot(tmpPnt,2);
  tmpPnt.x = -6.0; tmpPnt.y = 3.0; tmpPnt.z = 1.0;
  spl2->AddKnot(tmpPnt,3);
  tmpPnt.x =-4.0; tmpPnt.y = 4.0; tmpPnt.z = 1.0;
  spl2->AddKnot(tmpPnt,4);

  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  SG_SPLINE::Delete(spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,50);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 3);

  SG_POINT    ArP1;
  SG_POINT    ArP2;
  SG_POINT    ArP3;
  SG_ARC      ArcGeo;
  ArP1.x = -4.0; ArP1.y = 4.0; ArP1.z = 1.0;
  ArP2.x = 4.0; ArP2.y = 0.0; ArP2.z = 1.0;
  ArP3.x = 0.0; ArP3.y = 5.0; ArP3.z = -4.0;
  ArcGeo.FromThreePoints(ArP1,ArP2,ArP3,false);
  sgCArc* arcObj = sgCreateArc(ArcGeo);

  sgGetScene()->AttachObject(arcObj);
  arcObj->SetAttribute(SG_OA_COLOR,20);
  arcObj->SetAttribute(SG_OA_LINE_THICKNESS, 3);


  sgCObject* coons = sgSurfaces::Coons((const sgC2DObject&)*spl1_obj,
    (const sgC2DObject&)*spl2_obj,
    (const sgC2DObject&)*arcObj,
    NULL,36,36,4,4);

  sgC3DObject* obj3D = reinterpret_cast<sgC3DObject*>(coons);

  sgGetScene()->AttachObject(coons);
  coons->SetAttribute(SG_OA_COLOR,4);

  SG_VECTOR transV1 = {0,0,-0.4};
  coons->InitTempMatrix()->Translate(transV1);
  coons->ApplyTempMatrix();
  coons->DestroyTempMatrix();
}

void OnBnClickedSurfCoons4()
{
  sgGetScene()->Clear();

  

  SG_POINT tmpPnt;

  SG_SPLINE* spl1 = SG_SPLINE::Create();
 tmpPnt.x = -6.0; tmpPnt.y = 0.0; tmpPnt.z = -1.0;
  spl1->AddKnot(tmpPnt,0);
  tmpPnt.x = -5.0; tmpPnt.y = 0.0; tmpPnt.z = 2.0;
  spl1->AddKnot(tmpPnt,1);
  tmpPnt.x = -3.0; tmpPnt.y = 0.0; tmpPnt.z = -2.0;
  spl1->AddKnot(tmpPnt,2);
  tmpPnt.x = -2.0; tmpPnt.y = 0.0; tmpPnt.z = -2.0;
  spl1->AddKnot(tmpPnt,3);
  tmpPnt.x = -1.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl1->AddKnot(tmpPnt,4);
  tmpPnt.x =2.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl1->AddKnot(tmpPnt,5);
  tmpPnt.x =2.0; tmpPnt.y = 0.0; tmpPnt.z = 0.0;
  spl1->AddKnot(tmpPnt,6);
  tmpPnt.x =4.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl1->AddKnot(tmpPnt,7);

  sgCSpline* spl1_obj = sgCreateSpline(*spl1);
  SG_SPLINE::Delete(spl1);
  sgGetScene()->AttachObject(spl1_obj);
  spl1_obj->SetAttribute(SG_OA_COLOR,0);
  spl1_obj->SetAttribute(SG_OA_LINE_THICKNESS, 1);



  SG_SPLINE* spl2 = SG_SPLINE::Create();

  tmpPnt.x = -5.0; tmpPnt.y = 4.0; tmpPnt.z = 2.0;
  spl2->AddKnot(tmpPnt,0);
  tmpPnt.x = -3.0; tmpPnt.y = 4.0; tmpPnt.z = 1.0;
  spl2->AddKnot(tmpPnt,1);
  tmpPnt.x = -2.0; tmpPnt.y = 4.0; tmpPnt.z = 2.0;
  spl2->AddKnot(tmpPnt,2);
  tmpPnt.x = -1.0; tmpPnt.y = 4.0; tmpPnt.z = -1.0;
  spl2->AddKnot(tmpPnt,3);
  tmpPnt.x =4.0; tmpPnt.y = 4.0; tmpPnt.z = 0.0;
  spl2->AddKnot(tmpPnt,4);

  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  SG_SPLINE::Delete(spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,10);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);


  SG_SPLINE* spl3 = SG_SPLINE::Create();

  tmpPnt.x = -6.0; tmpPnt.y = 0.0; tmpPnt.z = -1.0;
  spl3->AddKnot(tmpPnt,0);
  tmpPnt.x = -7.0; tmpPnt.y = 0.5; tmpPnt.z = 3.0;
  spl3->AddKnot(tmpPnt,1);
  tmpPnt.x = -4.0; tmpPnt.y = 2.0; tmpPnt.z = -1.0;
  spl3->AddKnot(tmpPnt,2);
  tmpPnt.x = -5.0; tmpPnt.y = 3.0; tmpPnt.z = 1.0;
  spl3->AddKnot(tmpPnt,3);
  tmpPnt.x =-5.0; tmpPnt.y = 4.0; tmpPnt.z = 2.0;
  spl3->AddKnot(tmpPnt,4);

  sgCSpline* spl3_obj = sgCreateSpline(*spl3);
  SG_SPLINE::Delete(spl3);
  sgGetScene()->AttachObject(spl3_obj);
  spl3_obj->SetAttribute(SG_OA_COLOR,50);
  spl3_obj->SetAttribute(SG_OA_LINE_THICKNESS, 3);


  SG_SPLINE* spl4 = SG_SPLINE::Create();

  tmpPnt.x = 4.0; tmpPnt.y = 0.0; tmpPnt.z = 1.0;
  spl4->AddKnot(tmpPnt,0);
  tmpPnt.x = 3.0; tmpPnt.y = 1.0; tmpPnt.z = 2.0;
  spl4->AddKnot(tmpPnt,1);
  tmpPnt.x = 5.0; tmpPnt.y = 2.0; tmpPnt.z = -1.0;
  spl4->AddKnot(tmpPnt,2);
  tmpPnt.x = 3.0; tmpPnt.y = 3.0; tmpPnt.z = 0.5;
  spl4->AddKnot(tmpPnt,3);
  tmpPnt.x =4.0; tmpPnt.y = 4.0; tmpPnt.z = 0.0;
  spl4->AddKnot(tmpPnt,4);

  sgCSpline* spl4_obj = sgCreateSpline(*spl4);
  SG_SPLINE::Delete(spl4);
  sgGetScene()->AttachObject(spl4_obj);
  spl4_obj->SetAttribute(SG_OA_COLOR,100);
  spl4_obj->SetAttribute(SG_OA_LINE_THICKNESS, 4);



  sgCObject* coons = sgSurfaces::Coons((const sgC2DObject&)*spl1_obj,
                    (const sgC2DObject&)*spl2_obj,
                    (const sgC2DObject&)*spl3_obj,
                    (const sgC2DObject*)spl4_obj,36,36,4,4);

  sgC3DObject* obj3D = reinterpret_cast<sgC3DObject*>(coons);

  
  sgGetScene()->AttachObject(coons);
  coons->SetAttribute(SG_OA_COLOR,4);

  SG_VECTOR transV1 = {0,0,-0.3};
  coons->InitTempMatrix()->Translate(transV1);
  coons->ApplyTempMatrix();
  coons->DestroyTempMatrix();

}

void OnBnClickedSurfLinear()
{
  sgGetScene()->Clear();

  AddFloorInScene(30.0, 30.0, 2.0, 5.0, -2.0);


  SG_POINT tmpPnt;

   SG_SPLINE* spl1 = SG_SPLINE::Create();
  int fl=0;
  for (double i=0.0;i<2.0*3.14159265;i+=0.4)
  {
    tmpPnt.x = ((double)(fl%3+2))*cos(i);
    tmpPnt.y = ((double)(fl%3+2))*sin(i);
    tmpPnt.z = 0.0;
    spl1->AddKnot(tmpPnt,fl);
    fl++;
  }
  spl1->Close();

  sgCSpline* spl1_obj = sgCreateSpline(*spl1);
  sgGetScene()->AttachObject(spl1_obj);
  spl1_obj->SetAttribute(SG_OA_COLOR,12);
  spl1_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  SG_SPLINE::Delete(spl1);

  SG_CIRCLE cirGeo;
  cirGeo.center.x = 2.0; cirGeo.center.y = -2.0; cirGeo.center.z = 8.0;
  cirGeo.normal.x = 0.0; cirGeo.normal.y = 0.0; cirGeo.normal.z = 1.0;
  cirGeo.radius = 1.5;
  sgCCircle* cir = sgCreateCircle(cirGeo);
  sgGetScene()->AttachObject(cir);
  cir->SetAttribute(SG_OA_COLOR,12);
  cir->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  
  sgC3DObject* linO1 = (sgC3DObject*)sgSurfaces::LinearSurfaceFromSections((const sgC2DObject&)(*spl1_obj),
            (const sgC2DObject&)(*cir),0.5,false);

  sgGetScene()->AttachObject(linO1);
  linO1->SetAttribute(SG_OA_COLOR,90);

  SG_VECTOR transV1 = {0,7,0};
  linO1->InitTempMatrix()->Translate(transV1);
  linO1->ApplyTempMatrix();
  linO1->DestroyTempMatrix();


  sgC3DObject* linO2 = (sgC3DObject*)sgSurfaces::LinearSurfaceFromSections((const sgC2DObject&)(*spl1_obj),
    (const sgC2DObject&)(*cir),0.7,true);

  sgGetScene()->AttachObject(linO2);
  linO2->SetAttribute(SG_OA_COLOR,150);

  transV1.x = 8.0; transV1.y = 0.0;
  linO2->InitTempMatrix()->Translate(transV1);
  linO2->ApplyTempMatrix();
  linO2->DestroyTempMatrix();

  
  sgC3DObject* linO3 = (sgC3DObject*)sgSurfaces::LinearSurfaceFromSections((const sgC2DObject&)(*spl1_obj),
    (const sgC2DObject&)(*cir),0.3,false);

  sgGetScene()->AttachObject(linO3);
  linO3->SetAttribute(SG_OA_COLOR,30);

  transV1.x = -8.0; transV1.y = 0.0;
  linO3->InitTempMatrix()->Translate(transV1);
  linO3->ApplyTempMatrix();
  linO3->DestroyTempMatrix();
}

void OnBnClickedSurfFromSect()
{
  sgGetScene()->Clear();

  
  SG_POINT tmpPnt;

  SG_SPLINE* spl1 = SG_SPLINE::Create();

  tmpPnt.x = 98.0; tmpPnt.y = 0.0; tmpPnt.z = -13.0;
  spl1->AddKnot(tmpPnt,0);
  tmpPnt.x = 85.0; tmpPnt.y = 0.0; tmpPnt.z = 19.0;
  spl1->AddKnot(tmpPnt,1);
  tmpPnt.x = 43.0; tmpPnt.y = 0.0; tmpPnt.z = -31.0;
  spl1->AddKnot(tmpPnt,2);
  tmpPnt.x = 5.0; tmpPnt.y = 0.0; tmpPnt.z = -3.0;
  spl1->AddKnot(tmpPnt,3);
  tmpPnt.x = -11.0; tmpPnt.y = 0.0; tmpPnt.z = -39.0;
  spl1->AddKnot(tmpPnt,4);
  tmpPnt.x =-48.0; tmpPnt.y = 0.0; tmpPnt.z = 23.0;
  spl1->AddKnot(tmpPnt,5);
  tmpPnt.x =-125.0; tmpPnt.y = 0.0; tmpPnt.z = 23.0;
  spl1->AddKnot(tmpPnt,6);

  sgCSpline* spl1_obj = sgCreateSpline(*spl1);
  SG_SPLINE::Delete(spl1);
  sgGetScene()->AttachObject(spl1_obj);
  spl1_obj->SetAttribute(SG_OA_COLOR,12);
  spl1_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);



  SG_SPLINE* spl2 = SG_SPLINE::Create();

  tmpPnt.x = 96.0; tmpPnt.y = 150.0; tmpPnt.z = 8.0;
  spl2->AddKnot(tmpPnt,0);
  tmpPnt.x = 66.0; tmpPnt.y = 150.0; tmpPnt.z = -20.0;
  spl2->AddKnot(tmpPnt,1);
  tmpPnt.x = 12.0; tmpPnt.y = 150.0; tmpPnt.z = 37.0;
  spl2->AddKnot(tmpPnt,2);
  tmpPnt.x = -128.0; tmpPnt.y = 150.0; tmpPnt.z = -23.0;
  spl2->AddKnot(tmpPnt,3);

  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  SG_SPLINE::Delete(spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,12);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);


  sgCLine* ln_obj = sgCreateLine(100.0,100.0,50.0, -121.0,100.0,-50.0);
  sgGetScene()->AttachObject(ln_obj);
  ln_obj->SetAttribute(SG_OA_COLOR,12);
  ln_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);


  SG_ARC arcG;
  SG_POINT arcBeg = {98.0, 50.0 , -80.0};
  SG_POINT arcEnd = {-117.0, 50.0 , -80.0};
  SG_POINT arcMid = {-55.0, 50.0 , -50.0};
  arcG.FromThreePoints(arcBeg,arcEnd,arcMid,false);
  sgCArc*  arc_obj = sgCreateArc(arcG);
  sgGetScene()->AttachObject(arc_obj);
  arc_obj->SetAttribute(SG_OA_COLOR,12);
  arc_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);


  sgC2DObject*  objcts[4];
  objcts[0] = spl1_obj;
  objcts[1] = arc_obj;
  objcts[2] = ln_obj;
  objcts[3] = spl2_obj;

  double param[4];
  param[0] = param[1] = param[2] = param[3] = 0.0;

  sgCObject* surf = sgSurfaces::SplineSurfaceFromSections((const sgC2DObject**)(objcts),
    param,4,false);

  sgGetScene()->AttachObject(surf);
  surf->SetAttribute(SG_OA_COLOR,24);

  SG_VECTOR transV1 = {0,0,-5};
  surf->InitTempMatrix()->Translate(transV1);
  surf->ApplyTempMatrix();
  surf->DestroyTempMatrix();
}

void OnBnClickedSurfBodyFromSect()
{
  sgGetScene()->Clear();

  AddFloorInScene(20.0, 20.0, 5.0, 2.0, -4.0);

  SG_POINT tmpPnt;
  SG_SPLINE* spl1 = SG_SPLINE::Create();
  int fl=0;
  for (double i=0.0;i<2.0*3.14159265;i+=0.4)
  {
    tmpPnt.x = ((double)(fl%3+2))*cos(i);
    tmpPnt.y = ((double)(fl%3+2))*sin(i);
    tmpPnt.z = 0.0;
    spl1->AddKnot(tmpPnt,fl);
    fl++;
  }
  spl1->Close();

  sgCSpline* spl1_obj = sgCreateSpline(*spl1);
  SG_SPLINE::Delete(spl1);
  sgGetScene()->AttachObject(spl1_obj);
  spl1_obj->SetAttribute(SG_OA_COLOR,12);
  spl1_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);



  SG_SPLINE* spl2 = SG_SPLINE::Create();

  tmpPnt.x = 0.0; tmpPnt.y = -0.9; tmpPnt.z = 2.0;
  spl2->AddKnot(tmpPnt,0);
  tmpPnt.x = 1.4; tmpPnt.y = 0.9; tmpPnt.z = 2.0;
  spl2->AddKnot(tmpPnt,1);
  tmpPnt.x = -1.6; tmpPnt.y = 0.6; tmpPnt.z = 2.0;
  spl2->AddKnot(tmpPnt,2);
  tmpPnt.x = -1.2; tmpPnt.y = -1.6; tmpPnt.z = 2.0;
  spl2->AddKnot(tmpPnt,3);
  spl2->Close();


  sgCSpline* spl2_obj = sgCreateSpline(*spl2);
  SG_SPLINE::Delete(spl2);
  sgGetScene()->AttachObject(spl2_obj);
  spl2_obj->SetAttribute(SG_OA_COLOR,12);
  spl2_obj->SetAttribute(SG_OA_LINE_THICKNESS, 2);

  sgC2DObject* ooo[3];
  ooo[1] = spl1_obj;
  ooo[0] = spl2_obj;
  ooo[2] = (sgC2DObject*)spl2_obj->Clone();

  sgGetScene()->AttachObject(ooo[2]);

  SG_POINT axeP = {0.0, 0.0, 0.0};
  SG_VECTOR axeD = {0.0, 0.0, 1.0};
  //ooo[2]->InitTempMatrix()->Rotate(axeP,axeD, -3.14159265/5.0);
  axeD.z = 0.0; axeD.x = 1.0;
  ooo[2]->InitTempMatrix()->Rotate(axeP,axeD, 3.14159265/4.0);
  SG_VECTOR trV = {-1.0, 1.0, -3.0};
  ooo[2]->GetTempMatrix()->Translate(trV);
  ooo[2]->ApplyTempMatrix();
  ooo[2]->DestroyTempMatrix();


  double ppp[3];
  ppp[0] = 0.1;
  ppp[1] = 0.0;
  ppp[2] = 0.2;


  sgCObject* lsf = sgSurfaces::SplineSurfaceFromSections((const sgC2DObject**)(&ooo[0]),
    ppp,3,true);

  
  sgGetScene()->AttachObject(lsf);
  lsf->SetAttribute(SG_OA_COLOR,23);

  SG_VECTOR transV1 = {8,0,0};
  lsf->InitTempMatrix()->Translate(transV1);
  lsf->ApplyTempMatrix();
  lsf->DestroyTempMatrix();
}
