//
//  Use this file to import your target's public headers that you would like to expose to Swift.
//
#import <Foundation/Foundation.h>

typedef void* sg_object;
typedef void* sg_object2D;
typedef void* sg_objectGroup;
typedef void* sg_object3D;
typedef float sg_float;

typedef struct {sg_float x; sg_float y; sg_float z;} sg_point;

#define  OT_UNKNOWN   0
#define  OT_2D        1
#define  OT_GROUP     2
#define  OT_3D        3

#define COLOR_GRAY       0
#define COLOR_GREEN      1
#define COLOR_WHITE      2
#define COLOR_BLUE       3
#define COLOR_RED        4
#define COLOR_YELLOW     5
#define COLOR_GRAY_TR    6
#define COLOR_GREEN_TR   7
#define COLOR_WHITE_TR   8
#define COLOR_BLUE_TR    9
#define COLOR_RED_TR     10
#define COLOR_YELLOW_TR  11


@interface sgCore : NSObject

+(void) sg_init_library;
+(void) sg_free_library;

+(void)      sg_scene_attach:(sg_object)obj;
+(void)      sg_scene_detach:(sg_object)obj;
+(int)       sg_scene_get_objects_count;
+(sg_object) sg_scene_get_first_object;
+(sg_object) sg_scene_get_next_object:(sg_object)obj;
+(void)      sg_scene_clear;

+(void)        sg_delete_object:(sg_object)obj;
+(int)         sg_object_type:(sg_object)obj;
+(int)         sg_object_color:(sg_object)obj;


+(BOOL)        sg_is_close:(sg_object)obj;
+(BOOL)        sg_is_strip:(sg_object)obj;

+(sg_point)    sg_make_pointX:(sg_float)pX Y:(sg_float)pY Z:(sg_float)pZ;
+(sg_object2D) sg_make_line_from:(sg_point)p1 to:(sg_point)p2;
+(sg_object2D) sg_make_circle:(sg_float)radius center:(sg_point)cP normal:(sg_point)nrml;
+(sg_object2D) sg_make_arc:(sg_point)cent begin:(sg_point)begP end:(sg_point)endP;
+(sg_object2D) sg_make_spline:(sg_point*)knots count:(int)cnt close:(BOOL)cls;

+(int)         sg_get_group_sub_objects_count:(sg_objectGroup)obj;
+(sg_object)   sg_get_group_first_object:(sg_objectGroup)contour;
+(sg_object)   sg_get_group_next_object:(sg_objectGroup)contour after:(sg_object)obj;


+(int)         sg_get_points_count:(sg_object2D)obj;
+(sg_float*)   sg_get_points:(sg_object2D)obj;

+(sg_object3D) sg_make_sphere:(sg_float)radius meridians:(short)merid_cnt parallels:(short)parall_cnt;
+(sg_object3D) sg_make_torus:(sg_float)radius1 thickness:(sg_float)radius2 meridians:(short)merid_cnt parallels:(short)parall_cnt;


+(void)      sg_triangulate:(sg_object3D)obj;
+(int)       sg_get_triangles_count:(sg_object3D)obj;
+(sg_float*) sg_get_triangles_vertexes:(sg_object3D)obj;
+(sg_float*) sg_get_triangles_normals:(sg_object3D)obj;
+(sg_float*) sg_get_triangles_textures:(sg_object3D)obj;

+(sg_float)  sg_get_transform_item:(int)indx of_object:(sg_object3D)obj;


+(void)      test:(int)tInd;

@end
