using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using sgCoreWrapper.Objects;
using sgCoreWrapper.Structs;
using sgCoreWrapper;
using Demo.Scenes;

namespace Demo
{
	public partial class Demo : Form
	{
		public Demo()
		{
			InitializeComponent();

			msgCore.InitKernel();
			msg3DObject.AutoTriangulate(true, msgTriangulationTypeEnum.SG_DELAUNAY_TRIANGULATION);
		}

		protected override void OnClosed(EventArgs e)
		{
			base.OnClosed(e);

			msgCore.FreeKernel(true);
		}

		private void boxesToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateBoxes();
            this.openGLControl1.Invalidate();
		}

		private void spheresToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateSpheres();
            this.openGLControl1.Invalidate();
		}

		private void cylindersToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateCylinders();
            this.openGLControl1.Invalidate();
		}

		private void conesToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateCones();
            this.openGLControl1.Invalidate();
		}

		private void torsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateTors();
            this.openGLControl1.Invalidate();
		}

		private void ellipsoidsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateEllipsoids();
            this.openGLControl1.Invalidate();
		}

		private void bandsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Primitives.CreateBands();
            this.openGLControl1.Invalidate();
		}

		private void intersectionToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Bool.CreateIntersection();
            this.openGLControl1.Invalidate();
		}

		private void unionToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Bool.CreateUnion();
            this.openGLControl1.Invalidate();
		}

		private void subToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Bool.CreateSub();
            this.openGLControl1.Invalidate();
		}

		private void intersectionContoursToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Bool.CreateIntersectionContours();
            this.openGLControl1.Invalidate();
		}

		private void sectionsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Bool.CreateSections();
            this.openGLControl1.Invalidate();
		}

		private void rotationSurfaceToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreateRotationSurface();
            this.openGLControl1.Invalidate();
		}

		private void rotationBodyToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreateRotationBody();
            this.openGLControl1.Invalidate();
		}

		private void extrudeSurfaceToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreateExtrudeSurfaces();
            this.openGLControl1.Invalidate();
		}

		private void extrudeBodyToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreateExtrudeBody();
            this.openGLControl1.Invalidate();
		}

		private void spiralSurfaceToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreateSpiralSurface();
            this.openGLControl1.Invalidate();
		}

		private void spiralBodyToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreateSpiralBody();
            this.openGLControl1.Invalidate();
		}

		private void pipeSurfaceToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreatePipeSurface();
            this.openGLControl1.Invalidate();
		}

		private void pipeBodyToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Kinematic.CreatePipeBody();
            this.openGLControl1.Invalidate();
		}

		private void meshToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateMesh();
            this.openGLControl1.Invalidate();
		}

		private void faceToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateFace();
            this.openGLControl1.Invalidate();
		}

		private void coonsFrom3CurvesToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateCoonsFrom3Curves();
            this.openGLControl1.Invalidate();
		}

		private void coonsFrom4CurvesToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateCoonsFrom4Curves();
            this.openGLControl1.Invalidate();
		}

		private void linearToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateLinear();
            this.openGLControl1.Invalidate();
		}

		private void fromClipsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateFromClips();
            this.openGLControl1.Invalidate();
		}

		private void bodyFromClipsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Surface.CreateBodyFromClips();
            this.openGLControl1.Invalidate();
		}
	}
}