#import "Scenes.h"
#include <cstdlib>

#include "../../../../sgCore/sgCore.h"

static bool load_fonts()
{
	static bool wasLoad = false;
	if (wasLoad)
		return true;
    

	sgCFont* fnt1 = sgCFont::LoadFont("TXT.SHX",NULL,0);
	if (!fnt1)
	{
		return false;
	}
	if (!sgFontManager::AttachFont(fnt1))
	{
		sgCFont::UnloadFont(fnt1);
		return false;
	}

	sgCFont* fnt2 = sgCFont::LoadFont("ITALIC.SHX",NULL,0);
	if (!fnt2)
	{
		return false;
	}
	if (!sgFontManager::AttachFont(fnt2))
	{
		sgCFont::UnloadFont(fnt2);
		return false;
	}

	wasLoad = true;
	return true;
}

void OnBnClickedText1()
{
	sgGetScene()->Clear();

	if (!load_fonts())
		return;

	SG_TEXT_STYLE    text_style;

	text_style.state = 0;
	text_style.height= 0.5;
	text_style.proportions= 100.0;
	text_style.angle= 0.0;
	text_style.horiz_space_proportion= 0.0;
	text_style.vert_space_proportion= 50.0;

	sgCText* ttO = sgCText::Create(sgFontManager::GetFont(0),	text_style, "sgCore Demo String");
	sgGetScene()->AttachObject(ttO);

}

void OnBnClickedText2()
{
	sgGetScene()->Clear();

	if (!load_fonts())
		return;

	SG_TEXT_STYLE    text_style;

	text_style.state = 0;
	text_style.height= 0.5;
	text_style.proportions= 100.0;
	text_style.angle= 30.0;
	text_style.horiz_space_proportion= 0.0;
	text_style.vert_space_proportion= 50.0;

	sgCText* ttO = sgCText::Create(sgFontManager::GetFont(1),	text_style, "sgCore Demo \r\n String2");
	sgGetScene()->AttachObject(ttO);

}

void OnBnClickedDim1()
{
  sgGetScene()->Clear();
	if (!load_fonts())
		return;

	SG_DIMENSION_STYLE        dim_style;

	dim_style.behaviour_type = SG_DBT_PARALLEL;
	dim_style.dimension_line = true;
	dim_style.first_side_line = true;
	dim_style.second_side_line = true;
	dim_style.lug_size = 0.5;

	dim_style.automatic_arrows = true;

	dim_style.out_first_arrow = false;
	dim_style.first_arrow_style = 1;

	dim_style.out_second_arrow= false;
	dim_style.second_arrow_style= 1;

	dim_style.arrows_size= 1.1;

	dim_style.text_align = SG_TA_CENTER;

	dim_style.text_style.state = 0;
	dim_style.text_style.height= 0.4;
	dim_style.text_style.proportions= 100.0;
	dim_style.text_style.angle= 30.0;
	dim_style.text_style.horiz_space_proportion= 0.0;
	dim_style.text_style.vert_space_proportion= 50.0; 

	dim_style.precision = 3;

	SG_POINT ppp[3];
	ppp[0].x = ppp[0].y = ppp[0].z = 0;
	ppp[1].x = 17.0; ppp[1].y = ppp[1].z = 0;
	ppp[2].x = 10.0; ppp[2].y = 5.0; ppp[2].z = 0;
	sgCDimensions* dm = sgCDimensions::Create(SG_DT_LINEAR,ppp,	sgFontManager::GetFont(0),dim_style,	NULL);

	sgGetScene()->AttachObject(dm);



}

void OnBnClickedDim2()
{
	sgGetScene()->Clear();
	if (!load_fonts())
		return;

	SG_DIMENSION_STYLE        dim_style;

	dim_style.dimension_line = true;
	dim_style.first_side_line = true;
	dim_style.second_side_line = true;
	dim_style.lug_size = 0.5;

	dim_style.automatic_arrows = true;

	dim_style.out_first_arrow = false;
	dim_style.first_arrow_style = 1;

	dim_style.out_second_arrow= false;
	dim_style.second_arrow_style= 1;

	dim_style.arrows_size= 1.1;

	dim_style.text_align = SG_TA_CENTER;

	dim_style.text_style.state = 0;
	dim_style.text_style.height= 0.4;
	dim_style.text_style.proportions= 100.0;
	dim_style.text_style.angle= 30.0;
	dim_style.text_style.horiz_space_proportion= 0.0;
	dim_style.text_style.vert_space_proportion= 50.0; 

	dim_style.precision = 8;

	dim_style.invert = false;


	SG_POINT ppp[5];
	ppp[0].x = 0.0;  ppp[0].y = 5.0; ppp[0].z = 0;
	ppp[1].x = 0.0;  ppp[1].y = 0.0; ppp[1].z = 0;
	ppp[2].x = 3.0;  ppp[2].y = 5.0; ppp[2].z = 0;
	ppp[3].x = 6.0;  ppp[3].y = 0.0; ppp[3].z = 0;
	ppp[4].x = 1.0;  ppp[4].y = 1.0; ppp[4].z = 0;
	sgCDimensions* dm = sgCDimensions::Create(SG_DT_ANGLE,ppp,	sgFontManager::GetFont(1),dim_style,	NULL);

	sgGetScene()->AttachObject(dm);

}

