
#import "sgMasterViewController.h"

#import "sgDetailViewController.h"

#import "ogl/Scenes/Scenes.h"


@implementation sgMasterViewController

@synthesize detailViewController = _detailViewController;

- (void)awakeFromNib
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
        self.clearsSelectionOnViewWillAppear = NO;
        self.contentSizeForViewInPopover = CGSizeMake(320.0, 600.0);
    }
    [super awakeFromNib];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath 
{
   // NSLog(@"Selected row at index path: %@", indexPath);    
    int scene_id = [indexPath indexAtPosition:1];
    
    switch (scene_id) 
    {
            
        case 0: OnBnClickedBInters();break;
        case 1: OnBnClickedBUnion();break;
        case 2: OnBnClickedBSub();break;
        case 3: OnBnClickedBIntCont();break;
        case 4: OnBnClickedBSection();break;
            
        case 5: OnBnClickedKinRotSurf();break;
        case 6: OnBnClickedKinRotBod();break;
        case 7: OnBnClickedKinExtrSurf();break;
        case 8: OnBnClickedKinExtrBod();break;
        case 9: OnBnClickedKinSpirSurf();break;
        case 10: OnBnClickedKinSpirBod();break;
        case 11: OnBnClickedKinPipeSurf();break;
        case 12: OnBnClickedKinPipeBod();break;
            
        case 13: OnBnClickedSurfMesh();break;
        case 14: OnBnClickedSurfFace();break;
        case 15: OnBnClickedSurfCoons3();break;
        case 16: OnBnClickedSurfCoons4();break;
        case 17: OnBnClickedSurfLinear();break;
        case 18: OnBnClickedSurfFromSect();break;
        case 19: OnBnClickedSurfBodyFromSect();break;
            
        case 20: OnBnClickedScenesRoom();break;
        case 21: OnBnClickedScenesDrills();break;
        case 22: OnBnClickedScenesClock();break;
            
        case 23: OnBnClickedPrPoints();break;
        case 24: OnBnClickedPrLines();break;
        case 25: OnBnClickedPrCircles();break;
        case 26: OnBnClickedPrArcs();break;
        case 27: OnBnClickedPrSplines();break;
        case 28: OnBnClickedPrContours();break;
        case 29: OnBnClickedPrEquidi();break;
        case 30: OnBnClickedPrBoxes();break;
        case 31: OnBnClickedPrSpheres();break;
        case 32: OnBnClickedPrCyls();break;
        case 33: OnBnClickedPrCones();break;
        case 34: OnBnClickedPrTors();break;
        case 35: OnBnClickedPrEllipsoids();break;
        case 36: OnBnClickedPrSphericBands();break;
            
        default:
            break;
    }
    

}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    self.detailViewController = (sgDetailViewController *)[[self.splitViewController.viewControllers lastObject] topViewController];
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
        [self.tableView selectRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0] animated:NO scrollPosition:UITableViewScrollPositionMiddle];
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

@end
